pub type uint = u64;
pub type sint = i64;

#[derive(Default)]
pub struct BuildSeaHash;
impl core::hash::BuildHasher for BuildSeaHash {
	type Hasher = seahash::SeaHasher;

	fn build_hasher(&self) -> Self::Hasher {
		seahash::SeaHasher::new()
	}
}

pub type HashMap<K, V> = std::collections::HashMap<K, V, BuildSeaHash>;
pub type HashSet<K> = std::collections::HashSet<K, BuildSeaHash>;

pub mod prelude {
	pub use super::{sint, uint, HashMap, HashSet};
}
